/* ----------------------------------------------------------------------
(* Initial interface we agreed to be able to stub out *)

INTERFACE foo;

EXCEPTION zapexception : integer;

TYPE bar = OBJECT
  
  METHODS

    zap (IN inarg : integer, INOUT inoutarg : byte, OUT outarg : real ) : boolean RAISES zapexception END

  END;

----------------------------------------------------------------------
   Note on how the namespace macros expand             

                               underscore    namespace          class
                               ----------    ---------          -----
NAME_INSIDE_SCOPE(foo, name)   foo_name      name               name

NAME_OUTSIDE_SCOPE(foo, name)  foo_name      foo::name          foo::name

BEGIN_NAMESPACE(foo)           {nothing}     namespace foo {    class foo { public :

END_NAMESPACE(foo)             {nothing}     }                  }

---------------------------------------------------------------------- */
// What follows is what the header file, foo.h would contain when
// generated using the namespace mapping


/* This file was automatically generated with ILU (version 2.0alpha9) tools
 * at Fri Oct 11 11:15:38 1996 by `larner'
 * running "/opt/local/larner/ilu/bin/c++-stubber" of Wed Oct  9 12:38:20 1996
 * on "/afs/.parc.xerox.com/home/larner/temp/foo.isl" of Fri Oct 11 11:14:55 1996,
 * and "/opt/local/larner/ilu/interfaces/ilu.isl" of Wed Oct  9 12:38:06 1996.
 *
 * ILU is Copyright 1991-1996 Xerox Corporation, All Rights Reserved.
 * ILU information:  ftp://ftp.parc.xerox.com/pub/ilu/ilu.html.
 */


// Prevent multiple inclusions
#ifndef __foo_H_
#define __foo_H_

// Note ilucpp-corba.h includes ilucpp.h and ilucpp-templates.h

#include <corba.hpp>

// start the module scope
namespace foo {
	
	
	//////////////////////////////////////////////////////////////////////
	// Forward declarations and typedefs
	
	class   bar;
	typedef bar*    bar_ptr;
	typedef iluTemplatableObject_var<bar> bar_var;
	
	class   zapexception;
	
	// declarations for initialization
	extern void iluInitialize();
	extern int g_i_initialized;
	
	// indices for exceptions
	const iluCardinal g_zapexception_index = 0;

	extern iluInitializationFunctionNode* p_initialization_function_list;

	
	//////////////////////////////////////////////////////////////////////
	// For Clients, instances of _surrogate subclasses of this class will function 
	// as surrogates - that is, their IDL specified member functions will forward 
	// calls to the true object. Servers will subclass from this class, and supply 
	// the IDL specified member functions to provide the true object's implementations
	
	class  bar : public virtual CORBA::Object {
		
	public:

		// Constructs a new bar using pc_instance_handle as the instance
		// identifier, and puts the object under the specified iluServer.
		// If an_iluserver is NULL, the default server will be used.
		bar(char* pc_instance_handle, iluServer& r_an_ilu_server) : 
			iluObject(bar::m_ILUClassRecord, pc_instance_handle, r_an_ilu_server) {}
		
		// CORBA object reference operations
		static  bar_ptr _duplicate( bar_ptr a_bar_ptr );
		static  bar_ptr _narrow( CORBA::Object_ptr an_object_ptr ) {
			return (bar_ptr) an_object_ptr->iluDowncast(m_ILUClassRecord);
		}

		static  bar_ptr _nil();
		bar_ptr _this() { return _duplicate((bar_ptr)this); }
	
		// IDL specified methods 
		virtual CORBA::Boolean zap( CORBA::Long  inarg,
			CORBA::Octet&  inoutarg,
			CORBA::Double& outarg   ) throw (CORBA::SystemException, zapexception) = 0;
		
		// initialize to use of this class of objects - called by foo::iluInitialize
		static void iluInitialize();

		// Simple Object Lookup
		static bar_ptr iluLookup (char* pc_server_id, char* pc_instance_handle);

		// for ilu cpp runtime - stub use only - returns the m_ILUClassRecord member variable
		static iluClass iluGetClassRecord() {
			return m_ILUClassRecord;
		}
		
		// for use in narrowing
		virtual void* iluDowncast (iluClass class_to_cast_down_to);

    protected:
		
		// holds the kernel class for this kind of object
		static iluClass m_ILUClassRecord;
		
		bar();            // default constructor
		virtual ~bar();   // destructor		

	private:
		bar(const bar&);            // copy constructor
		void operator=(const bar&); // assignment operator		
	};
	
	
	
	//////////////////////////////////////////////////////////////////////
	// Exception Class
	
	class zapexception : public CORBA::UserException {
		
	public:		

		// constructors and destructor
		zapexception () {}; 
		zapexception (CORBA::Long l_value) : m_l_value(l_value) {}; 
		zapexception (const zapexception& a_zapexception); 
		~zapexception();

		// assignment operator
		zapexception& operator=(const zapexception& a_zapexception);

		// members
		CORBA::Long m_l_value;
	};
	

	//////////////////////////////////////////////////////////////////////
	// Initialization related
	
	// If you're using a C++ compiler which does not initialize all non-local
	// statics before running main (or you're doing something else which
	// could cause an unusual initialization order), you should use
	// one of the following three macros to perform your initialization
	// rather than simnply calling foo::iluInitialize();
	

#define ILU_INIT_foo_CLIENT_ONLY() { \
	foo_surrogate::g_the_bar_surrogate_initializer->ensure_instantiation(); \
	foo::iluInitialize(); \
	}

#define ILU_INIT_foo_SERVER_ONLY() { \
	foo_server::g_the_bar_server_initializer->ensure_instantiation(); \
	foo::iluInitialize(); \
	}	

#define ILU_INIT_foo_CLIENT_SERVER() { \
	foo_surrogate::g_the_bar_surrogate_initializer->ensure_instantiation(); \
	foo_true::g_the_bar_true_initializer->ensure_instantiation(); \
	foo::iluInitialize(); \
	}	
	
	//////////////////////////////////////////////////////////////////////
}; // end namespace foo

#endif /* __foo_H_ */


//////////////////////////////////////////////////////////////////////
// EOF
//////////////////////////////////////////////////////////////////////
