#include "foo-cpptrue.hpp"

// Globals and statics

int foo_true(bar_initializer)::initialized;
foo_true(bar_initializer) foo_true(bar_initializer)::sm_the_true_foo_bar_initializer;


// Exception Forwarding

static
void
_send_foo_zapexception(iluTrueCall & _true_call, foo(zapexception)& _exception) {
	try {
		// Size Return
		_true_call.iluSizeExceptionMode(g_foo_zapexception_index + 1);
		_true_call += _exception._m_value;
		// Send Reply
		_true_call << iluSendExceptionMode;
		_true_call << _exception._m_value;
	}
	catch (CORBA(SystemException)& _exception) {
		_true_call.iluSetErrorType(_exception.exception_kind());
	}
	catch (...) {
		ILUCPP_WARN_UNEXPECTED_EXCEPTION("_send_foo_zapexception");
		_true_call.iluSetErrorType(CORBA_ERRTYP(unknown));
	}
}

// Method Stubs

static
void
foo_bar_zap_stub (iluCall _call) {
	
	iluTrueCall _true_call(_call, ILUCPP_TRUE);
	
	try {
		
		foo(bar_ptr) _true_object;
		CORBA(Long) inarg;
		CORBA(Octet) inoutarg;
		CORBA(Double) outarg;
		CORBA(Boolean) return_value;
		iluBoolWrapper _return_value(return_value);
		iluObjectWrapper _discriminator(ILUCPP_TRUE, foo(bar)::iluGetILUClassRecord());
		
		// Read in discriminator
		_true_call >> _discriminator;
		_true_object = (foo(bar_ptr))(_discriminator.m_pv_iluobject);
		
		// Read in arguments
		_true_call >> inarg;
		_true_call >> inoutarg;
		_true_call << iluParametersFinishedMode;
		
		// Invoke actual method
		_return_value = _true_object->zap(inarg, inoutarg, outarg);

		// NOTE: if this were an ASYNCRONOUS CALL, this would
		// be the end of the try block

		// Size return
		if (_true_call.iluNeedsSizing()) {
			_true_call << iluSizeReplyMode;
			_true_call += _return_value;
			_true_call += inoutarg;
			_true_call += outarg;
		};
		
		// Send reply
		_true_call << iluSendReplyMode;
		_true_call << _return_value;
		_true_call << inoutarg;
		_true_call << outarg;
	}
	
	catch(foo(zapexception)& _exception) {
		_send_foo_zapexception(_true_call, _exception);
	}
	catch (CORBA(SystemException)& _exception) {
		_true_call.iluSetErrorType(_exception.exception_kind());
	}
	catch (...) {
		ILUCPP_WARN_UNEXPECTED_EXCEPTION("foo_bar_zap_stub");
		_true_call.iluSetErrorType(CORBA_ERRTYP(unknown));
	}
}



static
void
foo_bar_passobj_stub (iluCall _call) {
	
	iluTrueCall _true_call(_call, ILUCPP_FALSE);
	
	try {
		iluObjectWrapper _discriminator(ILUCPP_TRUE, foo(bar)::iluGetILUClassRecord());
		iluObjectWrapper _inarg(ILUCPP_FALSE, foo(bar)::iluGetILUClassRecord());
		iluObjectWrapper _inoutarg(ILUCPP_FALSE, foo(bar)::iluGetILUClassRecord());
		foo(bar_ptr) p_outarg;
		foo(bar_ptr) p_return_value;
		
		foo(bar_ptr) _true_object;
		
		// Read in discriminator
		_true_call >> _discriminator;
		_true_object = (foo(bar_ptr))(_discriminator.m_pv_iluobject);
		
		// Read in arguments
		_true_call >> _inarg;
		_true_call >> _inoutarg;
		_true_call << iluParametersFinishedMode;
		
		// Invoke actual method
		p_return_value = _true_object->passobj(
			(foo(bar_ptr))_inarg.m_pv_iluobject, 
			(foo(bar_ptr)&)_inoutarg.m_pv_iluobject, 
			p_outarg
			);

		_inoutarg.iluReviseForObject(((foo(bar_ptr))_inoutarg.m_pv_iluobject));
		iluObjectWrapper _return_value(*p_return_value, ILUCPP_FALSE);
		iluObjectWrapper _outarg(*p_outarg, ILUCPP_FALSE);
		
		/* NOTE: for all InOut, Out and return parameters that are supposed to be
		SIBLINGS, we need to perform a check to see that the object argument
		is in the same server as the discriminant (i.e. this)
		For example, suppose that outarg was supposed to be a SIBLING, we would do:

		// check for sibling
		if (! _true_object->iluInSameServer(p_outarg)) {
		 	// raise BAD_PARAM exception
			CORBA(BAD_PARAM) bad_param_not_a_sibling;
			throw(bad_param_not_a_sibling);
		}
		*/ 

		// Size return
		if (_true_call.iluNeedsSizing()) {
			_true_call << iluSizeReplyMode;
			_true_call += _return_value;
			_true_call += _inoutarg;
			_true_call += _outarg;
		};
		
		// Send reply
		_true_call << iluSendReplyMode;
		_true_call << _return_value;
		_true_call << _inoutarg;
		_true_call << _outarg;
	}
	
	catch (CORBA(SystemException)& _exception) {
		_true_call.iluSetErrorType(_exception.exception_kind());
	}
	catch (...) {
		ILUCPP_WARN_UNEXPECTED_EXCEPTION("foo_bar_passobj_stub");
		_true_call.iluSetErrorType(CORBA_ERRTYP(unknown));
	}
}


static
void
foo_bar_passenum_stub (iluCall _call) {
	
	iluTrueCall _true_call(_call, ILUCPP_FALSE);
	
	try {
		iluObjectWrapper _discriminator(ILUCPP_TRUE, foo(bar)::iluGetILUClassRecord());
		foo(bar_ptr)   _true_object;
		foo(enumtype)  return_value;
		iluEnumWrapper _return_value((iluDummyEnum&)return_value);
		foo(enumtype)  inarg;
		iluEnumWrapper _inarg((iluDummyEnum&)inarg);
		foo(enumtype)  inoutarg;
		iluEnumWrapper _inoutarg((iluDummyEnum&)inoutarg);
		foo(enumtype)  outarg;
		iluEnumWrapper _outarg((iluDummyEnum&)outarg);		
		
		// Read in discriminator
		_true_call >> _discriminator;
		_true_object = (foo(bar_ptr))(_discriminator.m_pv_iluobject);
		
		// Read in arguments
		_true_call >> _inarg;
		_true_call >> _inoutarg;
		_true_call << iluParametersFinishedMode;

		// Invoke actual method

#ifdef __GNUC__
		// use void * trickery to work around G++'s (2.7.2) problems with enum casting
		// note, this GNU workaround approach should work every where else, so
		// we may just want to do this for the general case.
		return_value = _true_object->passenum(
			(foo(enumtype))_inarg.m_r_enum, 
			*((foo(enumtype)*)((void*)(&(_inoutarg.m_r_enum)))),
			*((foo(enumtype)*)((void*)(&(_outarg.m_r_enum))))
			);
#else
		return_value = _true_object->passenum(
			(foo(enumtype))_inarg.m_r_enum, 
			(foo(enumtype)&)_inoutarg.m_r_enum, 
			(foo(enumtype)&)_outarg.m_r_enum 
			);
#endif
		
		// Size return
		if (_true_call.iluNeedsSizing()) {
			_true_call << iluSizeReplyMode;
			_true_call += _return_value;
			_true_call += _inoutarg;
			_true_call += _outarg;
		};
		
		// Send reply
		_true_call << iluSendReplyMode;
		_true_call << _return_value;
		_true_call << _inoutarg;
		_true_call << _outarg;
	}
	
	catch (CORBA(SystemException)& _exception) {
		_true_call.iluSetErrorType(_exception.exception_kind());
	}
	catch (...) {
		ILUCPP_WARN_UNEXPECTED_EXCEPTION("foo_bar_passenum_stub");
		_true_call.iluSetErrorType(CORBA_ERRTYP(unknown));
	}
}



static
void
foo_bar_passlatinstring_stub (iluCall _call) {
	
	iluTrueCall _true_call(_call, ILUCPP_FALSE);
	
	try {
		iluObjectWrapper _discriminator(ILUCPP_TRUE, foo(bar)::iluGetILUClassRecord());
		foo(bar_ptr)      _true_object;
		iluCardinal		  return_length;
		foo(LatinString)  return_value = NULL;
		iluCStringWrapper _return_value(return_value, return_length, ILUCPP_TRUE);
		iluCardinal		  inarg_length;
		foo(LatinString)  inarg = NULL;
		iluCStringWrapper _inarg(inarg, inarg_length, ILUCPP_TRUE);
		iluCardinal		  inoutarg_length;
		foo(LatinString)  inoutarg = NULL;
		iluCStringWrapper _inoutarg(inoutarg, inoutarg_length, ILUCPP_TRUE);
		iluCardinal		  outarg_length;
		foo(LatinString)  outarg = NULL;
		iluCStringWrapper _outarg(outarg, outarg_length, ILUCPP_TRUE);		
		
		// Read in discriminator
		_true_call >> _discriminator;
		_true_object = (foo(bar_ptr))(_discriminator.m_pv_iluobject);
		
		// Read in arguments
		_true_call >> _inarg;
		_true_call >> _inoutarg;
		_true_call << iluParametersFinishedMode;
		
		// Invoke actual method
		return_value = _true_object->passlatinstring(
			(foo(LatinString))_inarg.m_r_cstring, 
			(foo(LatinString)&)_inoutarg.m_r_cstring, 
			(foo(LatinString)&)_outarg.m_r_cstring 
			);
		
		_inoutarg.m_r_card_length = strlen(_inoutarg.m_r_cstring);
		_outarg.m_r_card_length = strlen(_outarg.m_r_cstring);
		
		_return_value.m_r_cstring = return_value;
		_return_value.m_r_card_length = strlen(_return_value.m_r_cstring);
		
		
		// Size return
		if (_true_call.iluNeedsSizing()) {
			_true_call << iluSizeReplyMode;
			_true_call += _return_value;
			_true_call += _inoutarg;
			_true_call += _outarg;
		};
		
		// Send reply
		_true_call << iluSendReplyMode;
		_true_call << _return_value;
		_true_call << _inoutarg;
		_true_call << _outarg;
	}
	
	catch (CORBA(SystemException)& _exception) {
		_true_call.iluSetErrorType(_exception.exception_kind());
	}
	catch (...) {
		ILUCPP_WARN_UNEXPECTED_EXCEPTION("foo_bar_passlatinstring_stub");
		_true_call.iluSetErrorType(CORBA_ERRTYP(unknown));
	}
}



static
void
foo_bar_passunicodestring_stub (iluCall _call) {
	
	iluTrueCall _true_call(_call, ILUCPP_FALSE);
	
	try {
		iluObjectWrapper _discriminator(ILUCPP_TRUE, foo(bar)::iluGetILUClassRecord());
		foo(bar_ptr)   _true_object;
		iluCardinal		  return_length;
		foo(UnicodeString)  return_value;
		iluWStringWrapper _return_value(return_value, return_length, ILUCPP_DELETE_ON_DESTRUCT);
		iluCardinal		  inarg_length;
		foo(UnicodeString)  inarg;
		iluWStringWrapper _inarg(inarg, inarg_length, ILUCPP_DELETE_ON_DESTRUCT);
		iluCardinal		  inoutarg_length;
		foo(UnicodeString)  inoutarg;
		iluWStringWrapper _inoutarg(inoutarg, inoutarg_length, ILUCPP_DELETE_ON_DESTRUCT);
		iluCardinal		  outarg_length;
		foo(UnicodeString)  outarg;
		iluWStringWrapper _outarg(outarg, outarg_length, ILUCPP_DELETE_ON_DESTRUCT);		
		
		// Read in discriminator
		_true_call >> _discriminator;
		_true_object = (foo(bar_ptr))(_discriminator.m_pv_iluobject);
		
		// Read in arguments
		_true_call >> _inarg;
		_true_call >> _inoutarg;
		_true_call << iluParametersFinishedMode;
		
		// Invoke actual method
		return_value = _true_object->passunicodestring(
			(foo(UnicodeString))_inarg.m_r_wstring, 
			(foo(UnicodeString)&)_inoutarg.m_r_wstring, 
			(foo(UnicodeString)&)_outarg.m_r_wstring 
			);
		
		_inoutarg.m_r_card_length = iluCppRuntime::iluCharacterStringLength(_inoutarg.m_r_wstring);
		_outarg.m_r_card_length = iluCppRuntime::iluCharacterStringLength(_outarg.m_r_wstring);
		
		_return_value.m_r_wstring = return_value;
		_return_value.m_r_card_length = iluCppRuntime::iluCharacterStringLength(_return_value.m_r_wstring);
		
		// Size return
		if (_true_call.iluNeedsSizing()) {
			_true_call << iluSizeReplyMode;
			_true_call += _return_value;
			_true_call += _inoutarg;
			_true_call += _outarg;
		};
		
		// Send reply
		_true_call << iluSendReplyMode;
		_true_call << _return_value;
		_true_call << _inoutarg;
		_true_call << _outarg;
	}
	
	catch (CORBA(SystemException)& _exception) {
		_true_call.iluSetErrorType(_exception.exception_kind());
	}
	catch (...) {
		ILUCPP_WARN_UNEXPECTED_EXCEPTION("foo_bar_passunicodestring_stub");
		_true_call.iluSetErrorType(CORBA_ERRTYP(unknown));
	}
}

///////////////////////////////////////////////////////////////////////////

static
void
foo_bar_passfixedrecord_stub (iluCall _call) {
	
	iluTrueCall _true_call(_call, ILUCPP_FALSE);
	
	try {
		iluObjectWrapper _discriminator(ILUCPP_TRUE, foo(bar)::iluGetILUClassRecord());
		foo(bar_ptr)   _true_object;
		foo(fixedrecordtype) return_value; 
		foo(fixedrecordtype) inarg; 
		foo(fixedrecordtype) inoutarg; 
		foo(fixedrecordtype) outarg;
		
		// Read in discriminator
		_true_call >> _discriminator;
		_true_object = (foo(bar_ptr))(_discriminator.m_pv_iluobject);
		
		// Read in arguments
		_true_call >> inarg;
		_true_call >> inoutarg;
		_true_call << iluParametersFinishedMode;
		
		// Invoke actual method
		return_value = _true_object->passfixedrecord(
			inarg,
			inoutarg,
			outarg
			);
		
		// Size return
		if (_true_call.iluNeedsSizing()) {
			_true_call << iluSizeReplyMode;
			_true_call += return_value;
			_true_call += inoutarg;
			_true_call += outarg;
		};
		
		// Send reply
		_true_call << iluSendReplyMode;
		_true_call << return_value;
		_true_call << inoutarg;
		_true_call << outarg;
	}
	
	catch (CORBA(SystemException)& _exception) {
		_true_call.iluSetErrorType(_exception.exception_kind());
	}
	catch (...) {
		ILUCPP_WARN_UNEXPECTED_EXCEPTION("foo_bar_passfixedrecord_stub");
		_true_call.iluSetErrorType(CORBA_ERRTYP(unknown));
	}
}

///////////////////////////////////////////////////////////////////////////

static
void
foo_bar_passvariablerecord_stub (iluCall _call) {
	
	iluTrueCall _true_call(_call, ILUCPP_FALSE);
	
	try {
		iluObjectWrapper _discriminator(ILUCPP_TRUE, foo(bar)::iluGetILUClassRecord());
		foo(bar_ptr)   _true_object;
		foo(variablerecordtype)* p_return_value; 
		foo(variablerecordtype) inarg; 
		foo(variablerecordtype) inoutarg; 
		foo(variablerecordtype)* p_outarg;
		
		// Read in discriminator
		_true_call >> _discriminator;
		_true_object = (foo(bar_ptr))(_discriminator.m_pv_iluobject);
		
		// Read in arguments
		_true_call >> inarg;
		_true_call >> inoutarg;
		_true_call << iluParametersFinishedMode;
		
		// Invoke actual method
		p_return_value = _true_object->passvariablerecord(
			inarg,
			inoutarg,
			p_outarg
			);
		
		// Size return
		if (_true_call.iluNeedsSizing()) {
			_true_call << iluSizeReplyMode;
			_true_call += *p_return_value;
			_true_call += inoutarg;
			_true_call += *p_outarg;
		};
		
		// Send reply
		_true_call << iluSendReplyMode;
		_true_call << *p_return_value;
		delete p_return_value;
		_true_call << inoutarg;
		_true_call << *p_outarg;
		delete p_outarg;
	}
	
	catch (CORBA(SystemException)& _exception) {
		_true_call.iluSetErrorType(_exception.exception_kind());
	}
	catch (...) {
		ILUCPP_WARN_UNEXPECTED_EXCEPTION("foo_bar_passvariablerecord_stub");
		_true_call.iluSetErrorType(CORBA_ERRTYP(unknown));
	}
}

///////////////////////////////////////////////////////////////////////////

static
void
foo_bar_passfixedarray_stub (iluCall _call) {
	
	iluTrueCall _true_call(_call, ILUCPP_FALSE);
	
	try {
		iluObjectWrapper _discriminator(ILUCPP_TRUE, foo(bar)::iluGetILUClassRecord());
		foo(bar_ptr)   _true_object;
		foo(integerarray_var) return_value_var;
		foo(integerarray_slice)* inarg_slice = foo(integerarray_alloc)(); 
		foo(integerarray) inoutarg; 
		foo(integerarray) outarg;
		
		// Read in discriminator
		_true_call >> _discriminator;
		_true_object = (foo(bar_ptr))(_discriminator.m_pv_iluobject);
		
		// Read in arguments
		foo(input_integerarray)(_true_call, inarg_slice);
		foo(input_integerarray)(_true_call, inoutarg);
		_true_call << iluParametersFinishedMode;
		
		foo(integerarray_var) inarg_var(inarg_slice);

		// Invoke actual method

#ifdef __GNUC__		
		// use a slice to get around G++'s (2.7.2) inability to 
		// properly disambiguate between const and non const conversions of array_vars
		// note, this GNU workaround approach should work every where else, so
		// we may just want to do this for the general case.
		foo(integerarray_slice)* p_return_val_slice;

		p_return_val_slice = _true_object->passfixedarray(
			inarg_slice,
			inoutarg,
			outarg
			);

		// give the var ownership for memory management reasons
		return_value_var = p_return_val_slice;

		// Size return
		if (_true_call.iluNeedsSizing()) { 
			_true_call << iluSizeReplyMode;
			foo(size_integerarray)(_true_call, p_return_val_slice);
			foo(size_integerarray)(_true_call, inoutarg);
			foo(size_integerarray)(_true_call, outarg);
		};
		
		// Send reply
		_true_call << iluSendReplyMode;
		foo(output_integerarray)(_true_call, p_return_val_slice);
		foo(output_integerarray)(_true_call, inoutarg);
		foo(output_integerarray)(_true_call, outarg);
#else

		return_value_var = _true_object->passfixedarray(
			inarg_slice,
			inoutarg,
			outarg
			);
		
		// Size return
		if (_true_call.iluNeedsSizing()) { 
			_true_call << iluSizeReplyMode;
			foo(size_integerarray)(_true_call, return_value_var);
			foo(size_integerarray)(_true_call, inoutarg);
			foo(size_integerarray)(_true_call, outarg);
		};
		
		// Send reply
		_true_call << iluSendReplyMode;
		foo(output_integerarray)(_true_call, return_value_var);
		foo(output_integerarray)(_true_call, inoutarg);
		foo(output_integerarray)(_true_call, outarg);
#endif
	}
	
	catch (CORBA(SystemException)& _exception) {
		_true_call.iluSetErrorType(_exception.exception_kind());
	}
	catch (...) {
		ILUCPP_WARN_UNEXPECTED_EXCEPTION("foo_bar_passfixedarray_stub");
		_true_call.iluSetErrorType(CORBA_ERRTYP(unknown));
	}
}

///////////////////////////////////////////////////////////////////////////

static
void
foo_bar_passvariablearray_stub (iluCall _call) {
	
	iluTrueCall _true_call(_call, ILUCPP_FALSE);
	
	try {
		iluObjectWrapper _discriminator(ILUCPP_TRUE, foo(bar)::iluGetILUClassRecord());
		foo(bar_ptr)   _true_object;
		foo(bararray_var) return_value_var;
		foo(bararray_slice)* inarg_slice = foo(bararray_alloc)(); 
		foo(bararray) inoutarg; 
		foo(bararray_slice)* outarg_slice;
		
		// Read in discriminator
		_true_call >> _discriminator;
		_true_object = (foo(bar_ptr))(_discriminator.m_pv_iluobject);
		
		// Read in arguments
		foo(input_bararray)(_true_call, inarg_slice);
		foo(input_bararray)(_true_call, inoutarg);
		_true_call << iluParametersFinishedMode;
		
		// make up var to take care of memory management
		// and allow appropriate conversion for inarg for the inarg slice
		foo(bararray_var) inarg_var(inarg_slice);

		// Invoke actual method

#ifdef __GNUC__		
		// use a slice to get around G++'s (2.7.2) inability to 
		// properly disambiguate between const and non const conversions of array_vars
		// note, this GNU workaround approach should work every where else, so
		// we may just want to do this for the general case.
		foo(bararray_slice)* p_return_val_slice;

		p_return_val_slice  = _true_object->passvariablearray(
			inarg_slice,
			inoutarg,
			outarg_slice
			);

		// give the var ownership for memory management reasons
		return_value_var = p_return_val_slice;
		
		// make up var to take care of memory management
		foo(bararray_var) outarg_var(outarg_slice);
		
		// Size return
		if (_true_call.iluNeedsSizing()) {
			_true_call << iluSizeReplyMode;
			foo(size_bararray)(_true_call, p_return_val_slice);
			foo(size_bararray)(_true_call, inoutarg);
			foo(size_bararray)(_true_call, outarg_slice);
		};
		
		// Send reply
		_true_call << iluSendReplyMode;
		foo(output_bararray)(_true_call, p_return_val_slice);
		foo(output_bararray)(_true_call, inoutarg);
		foo(output_bararray)(_true_call, outarg_slice);

#else
		return_value_var = _true_object->passvariablearray(
			inarg_var,
			inoutarg,
			outarg_slice
			);
		
		// make up var to take care of memory management
		foo(bararray_var) outarg_var(outarg_slice);
		
		// Size return
		if (_true_call.iluNeedsSizing()) {
			_true_call << iluSizeReplyMode;
			foo(size_bararray)(_true_call, return_value_var);
			foo(size_bararray)(_true_call, inoutarg);
			foo(size_bararray)(_true_call, outarg_slice);
		};
		
		// Send reply
		_true_call << iluSendReplyMode;
		foo(output_bararray)(_true_call, return_value_var);
		foo(output_bararray)(_true_call, inoutarg);
		foo(output_bararray)(_true_call, outarg_slice);
#endif
	}
	
	catch (CORBA(SystemException)& _exception) {
		_true_call.iluSetErrorType(_exception.exception_kind());
	}
	catch (...) {
		ILUCPP_WARN_UNEXPECTED_EXCEPTION("foo_bar_passvariablearray_stub");
		_true_call.iluSetErrorType(CORBA_ERRTYP(unknown));
	}
}

///////////////////////////////////////////////////////////////////////////

static
void
foo_bar_passunboundedsequence_stub (iluCall _call) {
	
	iluTrueCall _true_call(_call, ILUCPP_FALSE);
	
	try {
		iluObjectWrapper _discriminator(ILUCPP_TRUE, foo(bar)::iluGetILUClassRecord());
		foo(bar_ptr)   _true_object;
		foo(unboundedlongseq)* p_return_value;
		foo(unboundedlongseq) inarg; 
		foo(unboundedlongseq) inoutarg; 
		foo(unboundedlongseq)* p_outarg;
		
		// Read in discriminator
		_true_call >> _discriminator;
		_true_object = (foo(bar_ptr))(_discriminator.m_pv_iluobject);
		
		// Read in arguments
		_true_call >> inarg;
		_true_call >> inoutarg;
		_true_call << iluParametersFinishedMode;
		
		// Invoke actual method
		p_return_value = _true_object->passunboundedsequence(
			inarg,
			inoutarg,
			p_outarg
			);
		
		// Size return
		if (_true_call.iluNeedsSizing()) {
			_true_call << iluSizeReplyMode;
			_true_call += *p_return_value;
			_true_call += inoutarg;
			_true_call += *p_outarg;
		};
		
		// Send reply
		_true_call << iluSendReplyMode;
		_true_call << *p_return_value;
		delete p_return_value;
		_true_call << inoutarg;
		_true_call << *p_outarg;
		delete p_outarg;
	}
	
	catch (CORBA(SystemException)& _exception) {
		_true_call.iluSetErrorType(_exception.exception_kind());
	}
	catch (...) {
		ILUCPP_WARN_UNEXPECTED_EXCEPTION("foo_bar_passunboundedsequence_stub");
		_true_call.iluSetErrorType(CORBA_ERRTYP(unknown));
	}
}

///////////////////////////////////////////////////////////////////////////

static
void
foo_bar_passboundedsequence_stub (iluCall _call) {
	
	iluTrueCall _true_call(_call, ILUCPP_FALSE);
	
	try {
		iluObjectWrapper _discriminator(ILUCPP_TRUE, foo(bar)::iluGetILUClassRecord());
		foo(bar_ptr)   _true_object;
		foo(boundedbarseq)* p_return_value;
		foo(boundedbarseq) inarg; 
		foo(boundedbarseq) inoutarg; 
		foo(boundedbarseq)* p_outarg;
		
		// Read in discriminator
		_true_call >> _discriminator;
		_true_object = (foo(bar_ptr))(_discriminator.m_pv_iluobject);
		
		// Read in arguments
		_true_call >> inarg;
		_true_call >> inoutarg;
		_true_call << iluParametersFinishedMode;
		
		// Invoke actual method
		p_return_value = _true_object->passboundedsequence(
			inarg,
			inoutarg,
			p_outarg
			);
		
		// Size return
		if (_true_call.iluNeedsSizing()) {
			_true_call << iluSizeReplyMode;
			_true_call += *p_return_value;
			_true_call += inoutarg;
			_true_call += *p_outarg;
		};
		
		// Send reply
		_true_call << iluSendReplyMode;
		_true_call << *p_return_value;
		delete p_return_value;
		_true_call << inoutarg;
		_true_call << *p_outarg;
		delete p_outarg;
	}
	
	catch (CORBA(SystemException)& _exception) {
		_true_call.iluSetErrorType(_exception.exception_kind());
	}
	catch (...) {
		ILUCPP_WARN_UNEXPECTED_EXCEPTION("foo_bar_passboundedsequence_stub");
		_true_call.iluSetErrorType(CORBA_ERRTYP(unknown));
	}
}

///////////////////////////////////////////////////////////////////////////

static
void
foo_bar_passvariableunion_stub (iluCall _call) {
	
	iluTrueCall _true_call(_call, ILUCPP_FALSE);
	
	try {
		iluObjectWrapper _discriminator(ILUCPP_TRUE, foo(bar)::iluGetILUClassRecord());
		foo(bar_ptr)   _true_object;
		foo(variableuniontype)* p_return_value;
		foo(variableuniontype) inarg; 
		foo(variableuniontype) inoutarg; 
		foo(variableuniontype)* p_outarg;
		
		// Read in discriminator
		_true_call >> _discriminator;
		_true_object = (foo(bar_ptr))(_discriminator.m_pv_iluobject);
		
		// Read in arguments
		_true_call >> inarg;
		_true_call >> inoutarg;
		_true_call << iluParametersFinishedMode;
		
		// Invoke actual method
		p_return_value = _true_object->passvariableunion(
			inarg,
			inoutarg,
			p_outarg
			);
		
		// Size return
		if (_true_call.iluNeedsSizing()) {
			_true_call << iluSizeReplyMode;
			_true_call += *p_return_value;
			_true_call += inoutarg;
			_true_call += *p_outarg;
		};
		
		// Send reply
		_true_call << iluSendReplyMode;
		_true_call << *p_return_value;
		delete p_return_value;
		_true_call << inoutarg;
		_true_call << *p_outarg;
		delete p_outarg;
	}
	
	catch (CORBA(SystemException)& _exception) {
		_true_call.iluSetErrorType(_exception.exception_kind());
	}
	catch (...) {
		ILUCPP_WARN_UNEXPECTED_EXCEPTION("foo_bar_passboundedsequence_stub");
		_true_call.iluSetErrorType(CORBA_ERRTYP(unknown));
	}
}

///////////////////////////////////////////////////////////////////////////

static
void
foo_bar_passoptionals_stub (iluCall _call) {
	
	iluTrueCall _true_call(_call, ILUCPP_FALSE);
	
	try {
		iluObjectWrapper _discriminator(ILUCPP_TRUE, foo(bar)::iluGetILUClassRecord());
		foo(bar_ptr)   _true_object;
		
		foo(optionalinteger) return_value;
		iluOptionalWrapper o_return_value;
		
		foo(optionalinteger) inarg; 
		iluOptionalWrapper o_inarg;
		CORBA(Long) inarg_value_holder;
		
		iluOptionalWrapper o_inoutarg;
		iluObjectWrapper _inoutarg(ILUCPP_FALSE, foo(bar)::iluGetILUClassRecord());
		
		foo(optionalbarobject) outarg;		
		iluOptionalWrapper o_outarg;
		
		// Read in discriminator
		_true_call >> _discriminator;
		_true_object = (foo(bar_ptr))(_discriminator.m_pv_iluobject);
		
		// Read in arguments
		_true_call >> o_inarg;
		if (o_inarg.m_present) {
			_true_call >> inarg_value_holder;
			inarg = &inarg_value_holder;
		}
		else inarg = NULL;
		
		_true_call >> o_inoutarg;
		if (o_inoutarg.m_present) {
			_true_call >> _inoutarg;
		}
		else _inoutarg.m_pv_iluobject = NULL;
		
		_true_call << iluParametersFinishedMode;
		
		// Invoke actual method
		return_value = _true_object->passoptionals(
			inarg,
			(foo(bar_ptr)&)_inoutarg.m_pv_iluobject, 
			outarg
			);
		
		_inoutarg.iluReviseForObject(((foo(bar_ptr))_inoutarg.m_pv_iluobject));
		o_return_value.iluSetFrom(return_value);
		o_inoutarg.iluSetFrom(_inoutarg.m_pv_iluobject);
		o_outarg.iluSetFrom(outarg);
		iluObjectWrapper _outarg(*outarg, ILUCPP_FALSE);
		
		
		// Size return
		if (_true_call.iluNeedsSizing()) {
			_true_call << iluSizeReplyMode;
			
			_true_call += o_return_value;
			if (o_return_value.m_present) 
				_true_call += *return_value;
			
			_true_call += o_inoutarg;
			if (o_inoutarg.m_present) 
				_true_call += _inoutarg;
			
			_true_call += o_outarg;
			if (o_outarg.m_present) 
				_true_call += _outarg;
		};
		
		// Send reply
		_true_call << iluSendReplyMode;		
		
		_true_call << o_return_value;
		if (o_return_value.m_present) 
			_true_call << *return_value;
		delete return_value;
		
		_true_call << o_inoutarg;
		if (o_inoutarg.m_present) 
			_true_call << _inoutarg;
		
		_true_call << o_outarg;
		if (o_outarg.m_present) 
			_true_call << _outarg;
		
	}
	
	catch (CORBA(SystemException)& _exception) {
		_true_call.iluSetErrorType(_exception.exception_kind());
	}
	catch (...) {
		ILUCPP_WARN_UNEXPECTED_EXCEPTION("foo_bar_passoptionals_stub");
		_true_call.iluSetErrorType(CORBA_ERRTYP(unknown));
	}
}

///////////////////////////////////////////////////////////////////////////
static
void
foo_bar_passsimpleanys_stub (iluCall _call) {
	
	iluTrueCall _true_call(_call, ILUCPP_FALSE);
	
	try {
		iluObjectWrapper _discriminator(ILUCPP_TRUE, foo(bar)::iluGetILUClassRecord());
		foo(bar_ptr)   _true_object;
		CORBA(Any)* p_return_value; 
		CORBA(Any) inarg; 
		CORBA(Any) inoutarg; 
		CORBA(Any)* p_outarg;
		
		// Read in discriminator
		_true_call >> _discriminator;
		_true_object = (foo(bar_ptr))(_discriminator.m_pv_iluobject);
		
		// Read in arguments
		_true_call >> inarg;
		_true_call >> inoutarg;
		_true_call << iluParametersFinishedMode;
		
		// Invoke actual method
		p_return_value = _true_object->passsimpleanys(
			inarg,
			inoutarg,
			p_outarg
			);
		
		// Size return
		if (_true_call.iluNeedsSizing()) {
			_true_call << iluSizeReplyMode;
			_true_call += *p_return_value;
			_true_call += inoutarg;
			_true_call += *p_outarg;
		};
		
		// Send reply
		_true_call << iluSendReplyMode;
		_true_call << *p_return_value;
		delete p_return_value;
		_true_call << inoutarg;
		_true_call << *p_outarg;
		delete p_outarg;
	}
	
	catch (CORBA(SystemException)& _exception) {
		_true_call.iluSetErrorType(_exception.exception_kind());
	}
	catch (...) {
		ILUCPP_WARN_UNEXPECTED_EXCEPTION("foo_bar_passsimpleanys_stub");
		_true_call.iluSetErrorType(CORBA_ERRTYP(unknown));
	}
}

///////////////////////////////////////////////////////////////////////////
static
void
foo_bar_passarrayanys_stub (iluCall _call) {
	
	iluTrueCall _true_call(_call, ILUCPP_FALSE);
	
	try {
		iluObjectWrapper _discriminator(ILUCPP_TRUE, foo(bar)::iluGetILUClassRecord());
		foo(bar_ptr)   _true_object;
		CORBA(Any)* p_return_value; 
		CORBA(Any) inarg; 
		CORBA(Any) inoutarg; 
		CORBA(Any)* p_outarg;
		
		// Read in discriminator
		_true_call >> _discriminator;
		_true_object = (foo(bar_ptr))(_discriminator.m_pv_iluobject);
		
		// Read in arguments
		_true_call >> inarg;
		_true_call >> inoutarg;
		_true_call << iluParametersFinishedMode;
		
		// Invoke actual method
		p_return_value = _true_object->passarrayanys(
			inarg,
			inoutarg,
			p_outarg
			);
		
		// Size return
		if (_true_call.iluNeedsSizing()) {
			_true_call << iluSizeReplyMode;
			_true_call += *p_return_value;
			_true_call += inoutarg;
			_true_call += *p_outarg;
		};
		
		// Send reply
		_true_call << iluSendReplyMode;
		_true_call << *p_return_value;
		delete p_return_value;
		_true_call << inoutarg;
		_true_call << *p_outarg;
		delete p_outarg;
	}
	
	catch (CORBA(SystemException)& _exception) {
		_true_call.iluSetErrorType(_exception.exception_kind());
	}
	catch (...) {
		ILUCPP_WARN_UNEXPECTED_EXCEPTION("foo_bar_passarrayanys_stub");
		_true_call.iluSetErrorType(CORBA_ERRTYP(unknown));
	} 
}

///////////////////////////////////////////////////////////////////////////
static
void
foo_bar_passassortedanys_stub (iluCall _call) {
	
	iluTrueCall _true_call(_call, ILUCPP_FALSE);
	
	try {
		iluObjectWrapper _discriminator(ILUCPP_TRUE, foo(bar)::iluGetILUClassRecord());
		foo(bar_ptr)   _true_object;
		CORBA(Any)* p_return_value; 
		CORBA(Any) inarg; 
		CORBA(Any) inoutarg; 
		CORBA(Any)* p_outarg;
		
		// Read in discriminator
		_true_call >> _discriminator;
		_true_object = (foo(bar_ptr))(_discriminator.m_pv_iluobject);
		
		// Read in arguments
		_true_call >> inarg;
		_true_call >> inoutarg;
		_true_call << iluParametersFinishedMode;
		
		// Invoke actual method
		p_return_value = _true_object->passassortedanys(
			inarg,
			inoutarg,
			p_outarg
			);
		
		// Size return
		if (_true_call.iluNeedsSizing()) {
			_true_call << iluSizeReplyMode;
			_true_call += *p_return_value;
			_true_call += inoutarg;
			_true_call += *p_outarg;
		};
		
		// Send reply
		_true_call << iluSendReplyMode;
		_true_call << *p_return_value;
		delete p_return_value;
		_true_call << inoutarg;
		_true_call << *p_outarg;
		delete p_outarg;
	}
	
	catch (CORBA(SystemException)& _exception) {
		_true_call.iluSetErrorType(_exception.exception_kind());
	}
	catch (...) {
		ILUCPP_WARN_UNEXPECTED_EXCEPTION("foo_bar_passassortedanys_stub");
		_true_call.iluSetErrorType(CORBA_ERRTYP(unknown));
	} 
}

///////////////////////////////////////////////////////////////////////////



// Class Initializers

foo_true(bar_initializer)::
foo_true_(bar_initializer) () {
	iluCppInternal::iluAddInitializationFunction(
		&foo(p_initialization_function_list),
		iluInitialize
		);
}

int
foo_true(bar_initializer)::
ensure_instantiation () {
	return REINTERPRET_CAST(int, this);
}

void
foo_true(bar_initializer)::
iluInitialize () {
	if (initialized == 1)
		return;
	ilu_SetMethodStubProc(
		foo(bar)::iluGetILUClassRecord()->cl_methods + 0,
		STATIC_CAST(ilu_StubProc, foo_bar_zap_stub), 
		iluCppInternal::iluGetCppLanguageIndex()
		);
	ilu_SetMethodStubProc(
		foo(bar)::iluGetILUClassRecord()->cl_methods + 1,
		STATIC_CAST(ilu_StubProc, foo_bar_passobj_stub), 
		iluCppInternal::iluGetCppLanguageIndex()
		);
	ilu_SetMethodStubProc(
		foo(bar)::iluGetILUClassRecord()->cl_methods + 2,
		STATIC_CAST(ilu_StubProc, foo_bar_passenum_stub), 
		iluCppInternal::iluGetCppLanguageIndex()
		);
	ilu_SetMethodStubProc(
		foo(bar)::iluGetILUClassRecord()->cl_methods + 3,
		STATIC_CAST(ilu_StubProc, foo_bar_passlatinstring_stub), 
		iluCppInternal::iluGetCppLanguageIndex()
		);
	ilu_SetMethodStubProc(
		foo(bar)::iluGetILUClassRecord()->cl_methods + 4,
		STATIC_CAST(ilu_StubProc, foo_bar_passunicodestring_stub), 
		iluCppInternal::iluGetCppLanguageIndex()
		); 
	ilu_SetMethodStubProc(
		foo(bar)::iluGetILUClassRecord()->cl_methods + 5,
		STATIC_CAST(ilu_StubProc, foo_bar_passfixedrecord_stub), 
		iluCppInternal::iluGetCppLanguageIndex()
		); 
	ilu_SetMethodStubProc(
		foo(bar)::iluGetILUClassRecord()->cl_methods + 6,
		STATIC_CAST(ilu_StubProc, foo_bar_passvariablerecord_stub), 
		iluCppInternal::iluGetCppLanguageIndex()
		); 
	ilu_SetMethodStubProc(
		foo(bar)::iluGetILUClassRecord()->cl_methods + 7,
		STATIC_CAST(ilu_StubProc, foo_bar_passfixedarray_stub), 
		iluCppInternal::iluGetCppLanguageIndex()
		); 
	ilu_SetMethodStubProc(
		foo(bar)::iluGetILUClassRecord()->cl_methods + 8,
		STATIC_CAST(ilu_StubProc, foo_bar_passvariablearray_stub), 
		iluCppInternal::iluGetCppLanguageIndex()
		); 
	ilu_SetMethodStubProc(
		foo(bar)::iluGetILUClassRecord()->cl_methods + 9,
		STATIC_CAST(ilu_StubProc, foo_bar_passunboundedsequence_stub), 
		iluCppInternal::iluGetCppLanguageIndex()
		); 
	ilu_SetMethodStubProc(
		foo(bar)::iluGetILUClassRecord()->cl_methods + 10,
		STATIC_CAST(ilu_StubProc, foo_bar_passboundedsequence_stub), 
		iluCppInternal::iluGetCppLanguageIndex()
		); 
	ilu_SetMethodStubProc(
		foo(bar)::iluGetILUClassRecord()->cl_methods + 11,
		STATIC_CAST(ilu_StubProc, foo_bar_passvariableunion_stub), 
		iluCppInternal::iluGetCppLanguageIndex()
		); 
	ilu_SetMethodStubProc(
		foo(bar)::iluGetILUClassRecord()->cl_methods + 12,
		STATIC_CAST(ilu_StubProc, foo_bar_passoptionals_stub), 
		iluCppInternal::iluGetCppLanguageIndex()
		); 
	ilu_SetMethodStubProc(
		foo(bar)::iluGetILUClassRecord()->cl_methods + 13,
		STATIC_CAST(ilu_StubProc, foo_bar_passsimpleanys_stub), 
		iluCppInternal::iluGetCppLanguageIndex()
		); 
	ilu_SetMethodStubProc(
		foo(bar)::iluGetILUClassRecord()->cl_methods + 14,
		STATIC_CAST(ilu_StubProc, foo_bar_passarrayanys_stub), 
		iluCppInternal::iluGetCppLanguageIndex()
		); 
	ilu_SetMethodStubProc(
		foo(bar)::iluGetILUClassRecord()->cl_methods + 15,
		STATIC_CAST(ilu_StubProc, foo_bar_passassortedanys_stub), 
		iluCppInternal::iluGetCppLanguageIndex()
		); 
	
	// for collectable objects, the following line is uncommented
	// NOTE: no longer needed - done by runtime, but benign if called 
	// iluCppInternal::iluEnsureGCNoter();
	
	initialized = 1;
}


